> ## Documentation Index
> Fetch the complete documentation index at: https://docs.plainid.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Export API Mapper Set By Filter

> Export API Mapper Set from the indicated Environment. This API call is designed to support EXPORT (read) operations in API Mapper Sets. <br>
<h2>Notice</h2>Accessing the API call is through a dedicated domain/URL, according to your PlainID Tenant Location<li><b>United States (US)</b> - `https://API.us1.plainid.io`</li><li><b>Canada (CA)</b> - `https://api.ca1.plainid.io`</li><li><b>Europe (EU)</b> - `https://api.eu1.plainid.io`</li> <br>
<h2>Using HTML Encoded Special Characters</h2> <p>Use HTML encoded patterns when working with values that contain special characters like spaces, dashes, etc. Refer to this <a href="https://www.w3schools.com/tags/ref_urlencode.ASP" target="_blank">HTML URL Encoding Reference</a> for a full list.</p> <br>
<h2>Important note about headers</h2> <p>Refer to the headers below to modify your cURL sample. Check if the following headers are in the sample, if not, ensure you add it to your cURL sample before pasting into your API tool. </p> <h3>Headers</h3> *Required <table><thead> <tr> <th>Header</th> <th>Value</th> <th>cURL Line</th> </tr></thead> <tbody> <tr> <td>Accept</td> <td>`application/json`</td> <td> `-H "Accept:application/json"`</td> </tr> </tbody> </table> <br>
<h3>cURL Sample Guidelines</h3> <p>In order for the relevant parameters to appear in the cURL sample, you can input the values in the interactive API console on the right in the Try It or Code Sample tabs. You can then copy the cURL sample from the Code Sample tab in the correct format.</p>

## OpenAPI

````json GET /api/1.0/api-mapper-sets/{envId}
{
  "openapi": "3.0.3",
  "info": {
    "title": "Management APIs",
    "version": "1.0.0",
    "contact": {
      "name": "PlainID",
      "url": "https://plainid.com",
      "email": "contact@plainid.com"
    },
    "license": {
      "name": "Commercial",
      "url": "https://plainid.com/license"
    },
    "termsOfService": "https://www.plainid.com/terms/",
    "description": "<h3>The PlainID Authorization Platform provides Management capabilities through the APIs below.</h3><h4> To access the Management APIs, make sure to enter your dedicated domain according to your PlainID Tenant Location:<table><thead><tr><th>Region</th><th>Base URL</th></tr></thead><tbody><tr><td>United States (US)</td><td>https://api.us1.plainid.io</td></tr><tr><td>Canada (CA)</td><td>https://api.ca1.plainid.io</td></tr><tr><td>Europe (EU)</td><td>https://api.eu1.plainid.io</td></tr><tr><td>Local PAA</td><td>https://api.plainid.local</td></tr></tbody></table>"
  },
  "servers": [
    {
      "description": "United States",
      "url": "https://api.us1.plainid.io"
    },
    {
      "description": "Europe",
      "url": "https://api.eu1.plainid.io"
    },
    {
      "description": "Canada",
      "url": "https://api.ca1.plainid.io"
    },
    {
      "description": "Local PAA",
      "url": "https://api.plainid.local"
    }
  ],
  "paths": {
    "/api/1.0/api-mapper-sets/{envId}": {
      "get": {
        "summary": "Export API Mapper Set By Filter",
        "operationId": "exportApiMapperSetList",
        "security": [
          {
            "bearerAuth": []
          }
        ],
        "description": "Export API Mapper Set from the indicated Environment. This API call is designed to support EXPORT (read) operations in API Mapper Sets. <br>\n<h2>Notice</h2>Accessing the API call is through a dedicated domain/URL, according to your PlainID Tenant Location<li><b>United States (US)</b> - `https://API.us1.plainid.io`</li><li><b>Canada (CA)</b> - `https://api.ca1.plainid.io`</li><li><b>Europe (EU)</b> - `https://api.eu1.plainid.io`</li> <br>\n<h2>Using HTML Encoded Special Characters</h2> <p>Use HTML encoded patterns when working with values that contain special characters like spaces, dashes, etc. Refer to this <a href=\"https://www.w3schools.com/tags/ref_urlencode.ASP\" target=\"_blank\">HTML URL Encoding Reference</a> for a full list.</p> <br>\n<h2>Important note about headers</h2> <p>Refer to the headers below to modify your cURL sample. Check if the following headers are in the sample, if not, ensure you add it to your cURL sample before pasting into your API tool. </p> <h3>Headers</h3> *Required <table><thead> <tr> <th>Header</th> <th>Value</th> <th>cURL Line</th> </tr></thead> <tbody> <tr> <td>Accept</td> <td>`application/json`</td> <td> `-H \"Accept:application/json\"`</td> </tr> </tbody> </table> <br>\n<h3>cURL Sample Guidelines</h3> <p>In order for the relevant parameters to appear in the cURL sample, you can input the values in the interactive API console on the right in the Try It or Code Sample tabs. You can then copy the cURL sample from the Code Sample tab in the correct format.</p>",
        "tags": [
          "Api Mapper"
        ],
        "parameters": [
          {
            "name": "envId",
            "in": "path",
            "required": "true",
            "schema": {
              "type": "string",
              "format": "uuid"
            },
            "description": "The Environment ID can be found under the Details Tab in the Environment Settings."
          },
          {
            "name": "offset",
            "in": "query",
            "description": "The starting point for return of records",
            "required": "false",
            "schema": {
              "type": "integer"
            }
          },
          {
            "name": "limit",
            "in": "query",
            "description": "Limit the number of records returned",
            "required": "false",
            "schema": {
              "type": "integer"
            }
          },
          {
            "name": "sort",
            "in": "query",
            "description": "Sorting order for API mappers set list",
            "required": "false",
            "schema": {
              "type": "object",
              "properties": {
                "priority": {
                  "description": "Field for sort",
                  "type": "string",
                  "enum": [
                    "ASC",
                    "DESC"
                  ]
                }
              }
            }
          },
          {
            "name": "filter",
            "in": "query",
            "description": "Filter to apply on api mapper set list",
            "required": "true",
            "style": "deepObject",
            "allowReserved": "true",
            "schema": {
              "type": "object",
              "required": [
                "applicationId"
              ],
              "properties": {
                "applicationId": {
                  "type": "string",
                  "format": "uuid",
                  "description": "Application id"
                }
              }
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successful operation",
            "headers": {
              "x-request-id": {
                "schema": {
                  "type": "string",
                  "format": "uuid"
                },
                "description": "The ID of the request"
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiMapperSetListResponse"
                },
                "examples": {
                  "example": {
                    "value": {
                      "data": [
                        {
                          "apiMappersSetId": "App1",
                          "applicationIds": [
                            "App1"
                          ],
                          "apiMappers": [
                            {
                              "mapperId": "mapper_1",
                              "displayName": "mapper-1",
                              "isActive": "true",
                              "matchPattern": "/bank/*/accountNum/**",
                              "matchType": "EXACT",
                              "restMethods": [
                                "GET",
                                "POST"
                              ],
                              "priority": "1",
                              "isRequireIdentitySourcesFiltering": "true",
                              "filteringType": "INCLUDE",
                              "identitySourceIds": [
                                "sourceId1234567"
                              ],
                              "assetTemplates": [
                                {
                                  "templateId": "accounts",
                                  "attributes": [
                                    {
                                      "attributeId": "acctType",
                                      "source": "PATH",
                                      "path": "[0]"
                                    }
                                  ],
                                  "actions": [
                                    {
                                      "actionId": "read",
                                      "source": "BODY",
                                      "value": "fetchData",
                                      "path": "$.function"
                                    }
                                  ]
                                },
                                {
                                  "templateId": "loans",
                                  "attributes": [],
                                  "actions": []
                                }
                              ]
                            },
                            {
                              "mapperId": "mapper_2",
                              "displayName": "mapper-2",
                              "description": "desc",
                              "isActive": "true",
                              "matchPattern": "/bank/*/loans/**",
                              "matchType": "EXACT",
                              "restMethods": [
                                "POST"
                              ],
                              "priority": "2",
                              "isRequireIdentitySourcesFiltering": "false",
                              "filteringType": "INCLUDE",
                              "identitySourceIds": [
                                "sourceId1234567"
                              ],
                              "assetTemplates": [
                                {
                                  "templateId": "loans",
                                  "attributes": [],
                                  "actions": []
                                }
                              ]
                            }
                          ]
                        }
                      ],
                      "meta": {
                        "limit": "20",
                        "offset": "0",
                        "total": "1"
                      }
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Validation Error",
            "headers": {
              "x-request-id": {
                "schema": {
                  "type": "string",
                  "format": "uuid"
                },
                "description": "The ID of the request"
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "headers": {
              "x-request-id": {
                "schema": {
                  "type": "string",
                  "format": "uuid"
                },
                "description": "The ID of the request"
              }
            }
          },
          "403": {
            "description": "Forbidden",
            "headers": {
              "x-request-id": {
                "schema": {
                  "type": "string",
                  "format": "uuid"
                },
                "description": "The ID of the request"
              }
            }
          },
          "404": {
            "description": "Object not found",
            "headers": {
              "x-request-id": {
                "schema": {
                  "type": "string",
                  "format": "uuid"
                },
                "description": "The ID of the request"
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "examples": {
                  "validationError": {
                    "$ref": "#/components/examples/apiMapperNotFound"
                  }
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error",
            "headers": {
              "x-request-id": {
                "schema": {
                  "type": "string",
                  "format": "uuid"
                },
                "description": "The ID of the request"
              }
            }
          }
        }
      }
    }
  },
  "components": {
    "schemas": {
      "ApiMapperSetListResponse": {
        "type": "object",
        "description": "Response object",
        "properties": {
          "data": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/ApiMapperSet"
            }
          },
          "meta": {
            "$ref": "#/components/schemas/meta"
          }
        }
      },
      "ErrorResponse": {
        "type": "object",
        "properties": {
          "code": {
            "type": "string"
          },
          "message": {
            "type": "string"
          },
          "details": {
            "type": "string"
          }
        }
      },
      "ApiMapperSet": {
        "type": "object",
        "description": "API Mapper Set",
        "required": [
          "apiMappersSetId",
          "applicationIds"
        ],
        "properties": {
          "apiMappersSetId": {
            "type": "string",
            "description": "API Mapper Set Unique Identifier.",
            "maxLength": "128",
            "minLength": "1",
            "pattern": "^[a-zA-Z0-9_:.-]+$"
          },
          "applicationIds": {
            "type": "array",
            "description": "Associated Application IDs. These IDs can be found in the individual **Application Details section under Application ID**.",
            "items": {
              "type": "string"
            }
          },
          "apiMappers": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/ApiMapper"
            }
          }
        }
      },
      "meta": {
        "type": "object",
        "description": "Response Meta",
        "properties": {
          "total": {
            "type": "integer",
            "description": "Total number of records"
          },
          "limit": {
            "type": "integer",
            "description": "Limit the number of records returned"
          },
          "offset": {
            "type": "integer",
            "description": "The starting point for return of records"
          }
        }
      },
      "ApiMapper": {
        "type": "object",
        "description": "API Mapper",
        "required": [
          "mapperId",
          "displayName",
          "isActive",
          "matchPattern",
          "matchType",
          "restMethods",
          "priority",
          "assetTemplates",
          "isRequireIdentitySourcesFiltering",
          "filteringType",
          "identitySourceIds"
        ],
        "properties": {
          "mapperId": {
            "type": "string",
            "description": "API Mapper Unique Identifier. This can be found the **API Mappers details** section within the relevant Application.",
            "maxLength": "128",
            "minLength": "1",
            "pattern": "^[a-zA-Z0-9_:.-]+$"
          },
          "displayName": {
            "type": "string",
            "description": "API Mapper Name",
            "maxLength": "100",
            "minLength": "1"
          },
          "description": {
            "description": "API Mapper Description",
            "type": "string",
            "maxLength": "200"
          },
          "isActive": {
            "type": "boolean",
            "description": "Indicates if the Mapper is active."
          },
          "matchPattern": {
            "type": "string",
            "description": "The URL pattern to which the Mapper applies."
          },
          "matchType": {
            "type": "string",
            "description": "Indicates if the matching is performed using a wildcard or exact match.",
            "enum": [
              "EXACT",
              "WILDCARDS",
              "REGEX"
            ]
          },
          "restMethods": {
            "type": "array",
            "description": "HTTP Methods that are applicable for the pattern.",
            "items": {
              "type": "string",
              "enum": [
                "GET",
                "POST",
                "PUT",
                "PATCH",
                "DELETE"
              ]
            }
          },
          "priority": {
            "type": "number",
            "description": "Mapper priority. Set the API Mapper priority to adjust the processing priority. For more information, see [Managing API Mappers](https://docs.plainid.io/docs/managing-api-mappers)."
          },
          "isRequireIdentitySourcesFiltering": {
            "type": "boolean",
            "description": "Indicates if the API Mapper requires Identity Source filtering."
          },
          "filteringType": {
            "type": "string",
            "description": "Indicates which Identity Source filtering type is required. This parameter is **required** if isRequireIdentitySourcesFiltering is set to `true`.",
            "enum": [
              "INCLUDE",
              "EXCLUDE"
            ]
          },
          "identitySourceIds": {
            "type": "array",
            "description": "Indicates which Identity Sources need to be filtered. This parameter is **required** if isRequireIdentitySourcesFiltering is set to `true`. This can be located in the **Source** tab in the **Identity Workspace Settings**.",
            "items": {
              "type": "string"
            }
          },
          "assetTemplates": {
            "type": "array",
            "description": "A list of Asset Templates associates with the API Mappers. You can locate Asset Template IDs under the relevant Assets' *Details* tab.",
            "items": {
              "$ref": "#/components/schemas/AssetTemplateApiMapping"
            }
          }
        }
      },
      "AssetTemplateApiMapping": {
        "type": "object",
        "description": "asset template api mapping",
        "required": [
          "templateId"
        ],
        "properties": {
          "templateId": {
            "type": "string",
            "description": "Asset Template unique identifier. You can locate the relevant Asset Template ID under the relevant Asset details."
          },
          "attributes": {
            "type": "array",
            "description": "List of Attributes associated with the Asset Template containing API Mappers. You can locate the relevant Attribute IDs under the relevant Assets' **Asset Attribute** tab.",
            "items": {
              "$ref": "#/components/schemas/AssetAttributesApiMapping"
            }
          },
          "actions": {
            "type": "array",
            "description": "A list of Actions associated with the Asset Template. You can locate the relevant Action IDs under the relevant Assets' **Actions** tab.",
            "items": {
              "$ref": "#/components/schemas/ActionApiMapping"
            }
          }
        }
      },
      "AssetAttributesApiMapping": {
        "type": "object",
        "required": [
          "attributeId",
          "source",
          "path"
        ],
        "properties": {
          "attributeId": {
            "type": "string",
            "description": "Attribute unique identifier. You can locate the relevant Attribute ID under the relevant Asset's **Asset Attribute** tab."
          },
          "source": {
            "type": "string",
            "description": "Idenity Source. You can locate it in the Attribute Mapping Settings section under the relevant Asset Type's Asset Attribute.",
            "enum": [
              "BODY",
              "HEADER",
              "PATH",
              "URI_REGEX"
            ]
          },
          "path": {
            "type": "string",
            "description": "JSON Path or relevant Path for the Attribute. You can locate it in the Attribute Mapping Settings section under the relevant Asset Type's Asset Attribute tab."
          }
        }
      },
      "ActionApiMapping": {
        "type": "object",
        "required": [
          "actionId",
          "source",
          "value",
          "path"
        ],
        "properties": {
          "actionId": {
            "type": "string",
            "description": "Action unique identifier. You can locate the relevant Action ID under the relevant Asset Type's **Actions** tab."
          },
          "source": {
            "type": "string",
            "description": "Action source. You can locate it in the API Action Mappers section under the relevant Asset Type's Action tab.",
            "enum": [
              "BODY",
              "HEADER",
              "PATH",
              "METHOD",
              "URI_REGEX"
            ]
          },
          "value": {
            "type": "string",
            "description": "Action value. You can locate it in the API Action Mappers section under the relevant Asset Type's Action tab."
          },
          "path": {
            "type": "string",
            "description": "Action path. You can locate it in the API Action Mappers section under the relevant Asset Type's Action tab."
          }
        }
      }
    },
    "examples": {
      "apiMapperNotFound": {
        "value": {
          "errors": [
            {
              "code": "APIV-002",
              "id": "EQ7CMX",
              "status": "404",
              "name": "ApiMapperNotFoundError",
              "message": "Api Mapper: [non-existing-id] not found in Environment: [2d4a0591-dfe4-45fb-8a69-d183f5c75c0d]"
            }
          ]
        }
      }
    }
  }
}
````

